import { defineNuxtPlugin as g, useRuntimeConfig as R } from "#app";
import { ref as p } from "vue";
const T = g({
  name: "msal",
  setup: async () => {
    if (import.meta.server)
      return {};
    const a = R(), { createStandardPublicClientApplication: f, InteractionRequiredAuthError: l, BrowserAuthError: h } = await import("@azure/msal-browser"), s = [a.public.appApiScope], c = { scopes: s, state: window.location.pathname }, e = await f({
      auth: {
        clientId: a.public.appId,
        authority: `https://login.microsoftonline.com/${a.public.appTenantId}`,
        postLogoutRedirectUri: `https://${window.location.host}/sign-out`,
        redirectUri: `https://${window.location.host}/`,
        navigateToLoginRequestUrl: !0
      },
      system: {
        iframeHashTimeout: 1e4,
        tokenRenewalOffsetSeconds: 300
      },
      cache: {
        cacheLocation: "localStorage",
        storeAuthStateInCookie: !1
      },
      ...a.public.msalConfig
    }), r = p(""), d = async () => {
      const t = await e.acquireTokenSilent({ scopes: s }).then(({ accessToken: o }) => o).catch(async (o) => (o instanceof l && await e.acquireTokenRedirect(c), ""));
      return r.value = t, t;
    };
    await e.handleRedirectPromise();
    const n = e.getAllAccounts();
    n.length === 0 ? await e.loginRedirect(c) : n[0] && e.setActiveAccount(n[0]);
    try {
      const { accessToken: t, account: o } = await e.acquireTokenSilent({
        scopes: s,
        refreshTokenExpirationOffsetSeconds: 300,
        forceRefresh: !0
      });
      e.setActiveAccount(o);
      const i = p();
      return (async () => {
        const { accessToken: m } = await e.acquireTokenSilent({
          scopes: ["User.Read"],
          account: n[0]
        }), u = await fetch("https://graph.microsoft.com/v1.0/me/photo/$value", {
          headers: {
            Authorization: `Bearer ${m}`
          }
        });
        if (u.ok) {
          const w = await u.blob();
          i.value = URL.createObjectURL(w);
        } else
          i.value = null;
      })().catch(() => {
        i.value = null;
      }), r.value = t, { provide: { msalInstance: e, accessTokenRef: r, profilePictureRef: i, refreshToken: d } };
    } catch (t) {
      return t instanceof l ? await e.loginRedirect(c) : t instanceof h && (sessionStorage.clear(), await e.loginRedirect(c)), {};
    }
  }
});
export {
  T as default
};
