import { defineNuxtPlugin as g, useRuntimeConfig as v, useNuxtApp as R, navigateTo as A } from "#app";
import { ref as h } from "vue";
const P = g(async (y) => {
  const { appApiUrl: u, appMode: l, mockServerPath: f } = v().public, c = new AbortController();
  if ((l === "offline-development" || l === "test") && typeof f == "string" && f !== "" && !!1) {
    const { createServer: i } = await import("miragejs"), { default: p } = await import("#build/mock-server");
    i({
      urlPrefix: u,
      ...p
    }).passthrough("/_nuxt/builds/meta/dev.json");
  }
  return {
    provide: {
      createApi: (i, p) => {
        const a = h(), { hookStrategy: n, onRequest: o, onRequestError: d, onResponse: r, onResponseError: s } = p ?? {
          onRequest: void 0,
          onRequestError: void 0,
          onResponse: void 0,
          onResponseError: void 0,
          hookStrategy: "merge"
        }, { $refreshToken: m } = R();
        return {
          statusCode: a,
          $api: $fetch.create({
            baseURL: u,
            signal: c.signal,
            async onRequest(e) {
              e.options.headers.set("Content-Type", "application/json"), typeof m == "function" && e.options.headers.set("Authorization", `Bearer ${await m()}`), o && n === "merge" && (Array.isArray(o) ? await Promise.all(o.map(async (t) => await t(e))) : o(e));
            },
            async onResponseError(e) {
              a.value = e.response.status, e.response.status === 401 && await y.runWithContext(() => A("/login")), s && n === "merge" && (Array.isArray(s) ? await Promise.all(s.map(async (t) => await t(e))) : s(e));
            },
            async onResponse(e) {
              a.value = e.response.status, r && n === "merge" && (Array.isArray(r) ? await Promise.all(r.map(async (t) => await t(e))) : r(e));
            },
            mode: "cors",
            ...i,
            ...n === "replace" ? {
              onRequest: o,
              onRequestError: d,
              onResponse: r,
              onResponseError: s
            } : {}
          })
        };
      },
      abortController: c
    }
  };
});
export {
  P as default
};
